<?php

/* ***********************************************************
 * This file was automatically generated on 2016-01-06.      *
 *                                                           *
 * PHP Bindings Version 2.1.7                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Measures UV Light
 */
class BrickletUVLight extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletUVLight::setUVLightCallbackPeriod(). The parameter is the UV Light 
     * intensity of the sensor.
     * 
     * BrickletUVLight::CALLBACK_UV_LIGHT is only triggered if the intensity has changed since the
     * last triggering.
     */
    const CALLBACK_UV_LIGHT = 8;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletUVLight::setUVLightCallbackThreshold() is reached.
     * The parameter is the UV Light intensity of the sensor.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletUVLight::setDebouncePeriod().
     */
    const CALLBACK_UV_LIGHT_REACHED = 9;


    /**
     * @internal
     */
    const FUNCTION_GET_UV_LIGHT = 1;

    /**
     * @internal
     */
    const FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 7;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';

    const DEVICE_IDENTIFIER = 265;

    const DEVICE_DISPLAY_NAME = "UV Light Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_UV_LIGHT] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_UV_LIGHT] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_UV_LIGHT_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_UV_LIGHT] = 'callbackWrapperUVLight';
        $this->callbackWrappers[self::CALLBACK_UV_LIGHT_REACHED] = 'callbackWrapperUVLightReached';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the UV Light intensity of the sensor, the intensity is given 
     * in µW/cm².
     * 
     * To get UV Index you have to divide the value by 250. For example, a UV Light
     * intensity of 500µW/cm² is equivalent to an UV Index of 2.
     * 
     * If you want to get the intensity periodically, it is recommended to use the
     * callback BrickletUVLight::CALLBACK_UV_LIGHT and set the period with 
     * BrickletUVLight::setUVLightCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getUVLight()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_UV_LIGHT, $payload);

        $payload = unpack('V1uv_light', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'uv_light');
    }

    /**
     * Sets the period in ms with which the BrickletUVLight::CALLBACK_UV_LIGHT callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * BrickletUVLight::CALLBACK_UV_LIGHT is only triggered if the intensity has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setUVLightCallbackPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletUVLight::setUVLightCallbackPeriod().
     * 
     * 
     * @return int
     */
    public function getUVLightCallbackPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletUVLight::CALLBACK_UV_LIGHT_REACHED callback. 
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the intensity is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the intensity is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the intensity is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the intensity is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setUVLightCallbackThreshold($option, $min, $max)
    {
        $payload = '';
        $payload .= pack('c', ord($option));
        $payload .= pack('V', $min);
        $payload .= pack('V', $max);

        $this->sendRequest(self::FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletUVLight::setUVLightCallbackThreshold().
     * 
     * 
     * @return array
     */
    public function getUVLightCallbackThreshold()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/V1min/V1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = IPConnection::fixUnpackedUInt32($payload, 'min');
        $result['max'] = IPConnection::fixUnpackedUInt32($payload, 'max');

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callbacks
     * 
     * * BrickletUVLight::CALLBACK_UV_LIGHT_REACHED,
     * 
     * are triggered, if the thresholds
     * 
     * * BrickletUVLight::setUVLightCallbackThreshold(),
     * 
     * keep being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletUVLight::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperUVLight($data)
    {
        $result = array();
        $payload = unpack('V1uv_light', $data);

        array_push($result, IPConnection::fixUnpackedUInt32($payload, 'uv_light'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_UV_LIGHT]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_UV_LIGHT], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperUVLightReached($data)
    {
        $result = array();
        $payload = unpack('V1uv_light', $data);

        array_push($result, IPConnection::fixUnpackedUInt32($payload, 'uv_light'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_UV_LIGHT_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_UV_LIGHT_REACHED], $result);
    }
}

?>
