<?php

/* ***********************************************************
 * This file was automatically generated on 2016-01-06.      *
 *                                                           *
 * PHP Bindings Version 2.1.7                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Full fledged AHRS with 9 degrees of freedom
 */
class BrickIMUV2 extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setAccelerationPeriod(). The parameters are the acceleration
     * for the x, y and z axis.
     */
    const CALLBACK_ACCELERATION = 32;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setMagneticFieldPeriod(). The parameters are the magnetic field
     * for the x, y and z axis.
     */
    const CALLBACK_MAGNETIC_FIELD = 33;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setAngularVelocityPeriod(). The parameters are the angular velocity
     * for the x, y and z axis.
     */
    const CALLBACK_ANGULAR_VELOCITY = 34;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setTemperaturePeriod(). The parameter is the temperature.
     */
    const CALLBACK_TEMPERATURE = 35;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setLinearAccelerationPeriod(). The parameters are the 
     * linear acceleration for the x, y and z axis.
     */
    const CALLBACK_LINEAR_ACCELERATION = 36;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setGravityVectorPeriod(). The parameters gravity vector
     * for the x, y and z axis.
     */
    const CALLBACK_GRAVITY_VECTOR = 37;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setOrientationPeriod(). The parameters are the orientation
     * (heading (yaw), roll, pitch) of the IMU Brick in Euler angles. See
     * BrickIMUV2::getOrientation() for details.
     */
    const CALLBACK_ORIENTATION = 38;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setQuaternionPeriod(). The parameters are the orientation
     * (x, y, z, w) of the IMU Brick in quaternions. See BrickIMUV2::getQuaternion()
     * for details.
     */
    const CALLBACK_QUATERNION = 39;

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickIMUV2::setAllDataPeriod(). The parameters are as for BrickIMUV2::getAllData().
     */
    const CALLBACK_ALL_DATA = 40;


    /**
     * @internal
     */
    const FUNCTION_GET_ACCELERATION = 1;

    /**
     * @internal
     */
    const FUNCTION_GET_MAGNETIC_FIELD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_ANGULAR_VELOCITY = 3;

    /**
     * @internal
     */
    const FUNCTION_GET_TEMPERATURE = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_ORIENTATION = 5;

    /**
     * @internal
     */
    const FUNCTION_GET_LINEAR_ACCELERATION = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_GRAVITY_VECTOR = 7;

    /**
     * @internal
     */
    const FUNCTION_GET_QUATERNION = 8;

    /**
     * @internal
     */
    const FUNCTION_GET_ALL_DATA = 9;

    /**
     * @internal
     */
    const FUNCTION_LEDS_ON = 10;

    /**
     * @internal
     */
    const FUNCTION_LEDS_OFF = 11;

    /**
     * @internal
     */
    const FUNCTION_ARE_LEDS_ON = 12;

    /**
     * @internal
     */
    const FUNCTION_SAVE_CALIBRATION = 13;

    /**
     * @internal
     */
    const FUNCTION_SET_ACCELERATION_PERIOD = 14;

    /**
     * @internal
     */
    const FUNCTION_GET_ACCELERATION_PERIOD = 15;

    /**
     * @internal
     */
    const FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 16;

    /**
     * @internal
     */
    const FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 17;

    /**
     * @internal
     */
    const FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 18;

    /**
     * @internal
     */
    const FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 19;

    /**
     * @internal
     */
    const FUNCTION_SET_TEMPERATURE_PERIOD = 20;

    /**
     * @internal
     */
    const FUNCTION_GET_TEMPERATURE_PERIOD = 21;

    /**
     * @internal
     */
    const FUNCTION_SET_ORIENTATION_PERIOD = 22;

    /**
     * @internal
     */
    const FUNCTION_GET_ORIENTATION_PERIOD = 23;

    /**
     * @internal
     */
    const FUNCTION_SET_LINEAR_ACCELERATION_PERIOD = 24;

    /**
     * @internal
     */
    const FUNCTION_GET_LINEAR_ACCELERATION_PERIOD = 25;

    /**
     * @internal
     */
    const FUNCTION_SET_GRAVITY_VECTOR_PERIOD = 26;

    /**
     * @internal
     */
    const FUNCTION_GET_GRAVITY_VECTOR_PERIOD = 27;

    /**
     * @internal
     */
    const FUNCTION_SET_QUATERNION_PERIOD = 28;

    /**
     * @internal
     */
    const FUNCTION_GET_QUATERNION_PERIOD = 29;

    /**
     * @internal
     */
    const FUNCTION_SET_ALL_DATA_PERIOD = 30;

    /**
     * @internal
     */
    const FUNCTION_GET_ALL_DATA_PERIOD = 31;

    /**
     * @internal
     */
    const FUNCTION_ENABLE_STATUS_LED = 238;

    /**
     * @internal
     */
    const FUNCTION_DISABLE_STATUS_LED = 239;

    /**
     * @internal
     */
    const FUNCTION_IS_STATUS_LED_ENABLED = 240;

    /**
     * @internal
     */
    const FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241;

    /**
     * @internal
     */
    const FUNCTION_GET_CHIP_TEMPERATURE = 242;

    /**
     * @internal
     */
    const FUNCTION_RESET = 243;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;


    const DEVICE_IDENTIFIER = 18;

    const DEVICE_DISPLAY_NAME = "IMU Brick 2.0";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_ACCELERATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_MAGNETIC_FIELD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ANGULAR_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ORIENTATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_LINEAR_ACCELERATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_GRAVITY_VECTOR] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_QUATERNION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ALL_DATA] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_LEDS_ON] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_LEDS_OFF] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_ARE_LEDS_ON] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SAVE_CALIBRATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ACCELERATION_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ACCELERATION_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_MAGNETIC_FIELD_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_MAGNETIC_FIELD_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ANGULAR_VELOCITY_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ANGULAR_VELOCITY_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_TEMPERATURE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_TEMPERATURE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ORIENTATION_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ORIENTATION_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_LINEAR_ACCELERATION_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_LINEAR_ACCELERATION_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_GRAVITY_VECTOR_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_GRAVITY_VECTOR_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_QUATERNION_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_QUATERNION_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_ALL_DATA_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ALL_DATA_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_ACCELERATION] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_MAGNETIC_FIELD] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_ANGULAR_VELOCITY] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_LINEAR_ACCELERATION] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_GRAVITY_VECTOR] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_ORIENTATION] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_QUATERNION] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_ALL_DATA] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_ENABLE_STATUS_LED] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_DISABLE_STATUS_LED] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_IS_STATUS_LED_ENABLED] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_CHIP_TEMPERATURE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_RESET] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_ACCELERATION] = 'callbackWrapperAcceleration';
        $this->callbackWrappers[self::CALLBACK_MAGNETIC_FIELD] = 'callbackWrapperMagneticField';
        $this->callbackWrappers[self::CALLBACK_ANGULAR_VELOCITY] = 'callbackWrapperAngularVelocity';
        $this->callbackWrappers[self::CALLBACK_TEMPERATURE] = 'callbackWrapperTemperature';
        $this->callbackWrappers[self::CALLBACK_LINEAR_ACCELERATION] = 'callbackWrapperLinearAcceleration';
        $this->callbackWrappers[self::CALLBACK_GRAVITY_VECTOR] = 'callbackWrapperGravityVector';
        $this->callbackWrappers[self::CALLBACK_ORIENTATION] = 'callbackWrapperOrientation';
        $this->callbackWrappers[self::CALLBACK_QUATERNION] = 'callbackWrapperQuaternion';
        $this->callbackWrappers[self::CALLBACK_ALL_DATA] = 'callbackWrapperAllData';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the calibrated acceleration from the accelerometer for the 
     * x, y and z axis in 1/100 m/s².
     * 
     * If you want to get the acceleration periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_ACCELERATION and set the period with 
     * BrickIMUV2::setAccelerationPeriod().
     * 
     * 
     * @return array
     */
    public function getAcceleration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ACCELERATION, $payload);

        $payload = unpack('v1x/v1y/v1z', $data);

        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Returns the calibrated magnetic field from the magnetometer for the 
     * x, y and z axis in 1/16 µT (Microtesla).
     * 
     * If you want to get the magnetic field periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_MAGNETIC_FIELD and set the period with 
     * BrickIMUV2::setMagneticFieldPeriod().
     * 
     * 
     * @return array
     */
    public function getMagneticField()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MAGNETIC_FIELD, $payload);

        $payload = unpack('v1x/v1y/v1z', $data);

        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Returns the calibrated angular velocity from the gyroscope for the 
     * x, y and z axis in 1/16 °/s.
     * 
     * If you want to get the angular velocity periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_ANGULAR_VELOCITY and set the period with 
     * BrickIMUV2::setAngularVelocityPeriod().
     * 
     * 
     * @return array
     */
    public function getAngularVelocity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ANGULAR_VELOCITY, $payload);

        $payload = unpack('v1x/v1y/v1z', $data);

        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Returns the temperature of the IMU Brick. The temperature is given in 
     * °C. The temperature is measured in the core of the BNO055 IC, it is not the
     * ambient temperature
     * 
     * 
     * @return int
     */
    public function getTemperature()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TEMPERATURE, $payload);

        $payload = unpack('c1temperature', $data);

        return $payload['temperature'];
    }

    /**
     * Returns the current orientation (heading, roll, pitch) of the IMU Brick as
     * independent Euler angles in 1/16 degree. Note that Euler angles always
     * experience a `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__. We
     * recommend that you use quaternions instead, if you need the absolute orientation.
     * 
     * The rotation angle has the following ranges:
     * 
     * * heading: 0° to 360°
     * * roll: -90° to +90°
     * * pitch: -180° to +180°
     * 
     * If you want to get the orientation periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_ORIENTATION and set the period with 
     * BrickIMUV2::setOrientationPeriod().
     * 
     * 
     * @return array
     */
    public function getOrientation()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ORIENTATION, $payload);

        $payload = unpack('v1heading/v1roll/v1pitch', $data);

        $result['heading'] = IPConnection::fixUnpackedInt16($payload, 'heading');
        $result['roll'] = IPConnection::fixUnpackedInt16($payload, 'roll');
        $result['pitch'] = IPConnection::fixUnpackedInt16($payload, 'pitch');

        return $result;
    }

    /**
     * Returns the linear acceleration of the IMU Brick for the
     * x, y and z axis in 1/100 m/s².
     * 
     * The linear acceleration is the acceleration in each of the three
     * axis of the IMU Brick with the influences of gravity removed.
     * 
     * It is also possible to get the gravity vector with the influence of linear
     * acceleration removed, see BrickIMUV2::getGravityVector().
     * 
     * If you want to get the linear acceleration periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_LINEAR_ACCELERATION and set the period with 
     * BrickIMUV2::setLinearAccelerationPeriod().
     * 
     * 
     * @return array
     */
    public function getLinearAcceleration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_LINEAR_ACCELERATION, $payload);

        $payload = unpack('v1x/v1y/v1z', $data);

        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Returns the current gravity vector of the IMU Brick for the
     * x, y and z axis in 1/100 m/s².
     * 
     * The gravity vector is the acceleration that occurs due to gravity.
     * Influences of additional linear acceleration are removed.
     * 
     * It is also possible to get the linear acceleration with the influence 
     * of gravity removed, see BrickIMUV2::getLinearAcceleration().
     * 
     * If you want to get the gravity vector periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_GRAVITY_VECTOR and set the period with 
     * BrickIMUV2::setGravityVectorPeriod().
     * 
     * 
     * @return array
     */
    public function getGravityVector()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_GRAVITY_VECTOR, $payload);

        $payload = unpack('v1x/v1y/v1z', $data);

        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Returns the current orientation (w, x, y, z) of the IMU Brick as
     * `quaternions <https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation>`__.
     * 
     * You have to divide the returns values by 16383 (14 bit) to get
     * the usual range of -1.0 to +1.0 for quaternions.
     * 
     * If you want to get the quaternions periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_QUATERNION and set the period with 
     * BrickIMUV2::setQuaternionPeriod().
     * 
     * 
     * @return array
     */
    public function getQuaternion()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_QUATERNION, $payload);

        $payload = unpack('v1w/v1x/v1y/v1z', $data);

        $result['w'] = IPConnection::fixUnpackedInt16($payload, 'w');
        $result['x'] = IPConnection::fixUnpackedInt16($payload, 'x');
        $result['y'] = IPConnection::fixUnpackedInt16($payload, 'y');
        $result['z'] = IPConnection::fixUnpackedInt16($payload, 'z');

        return $result;
    }

    /**
     * Return all of the available data of the IMU Brick.
     * 
     * * acceleration in 1/100 m/s² (see BrickIMUV2::getAcceleration())
     * * magnetic field in 1/16 µT (see BrickIMUV2::getMagneticField())
     * * angular velocity in 1/16 °/s (see BrickIMUV2::getAngularVelocity())
     * * Euler angles in 1/16 ° (see BrickIMUV2::getOrientation())
     * * quaternion 1/16383 (see BrickIMUV2::getQuaternion())
     * * linear acceleration 1/100 m/s² (see BrickIMUV2::getLinearAcceleration())
     * * gravity vector 1/100 m/s² (see BrickIMUV2::getGravityVector())
     * * temperature in 1 °C (see BrickIMUV2::getTemperature())
     * * calibration status (see below)
     * 
     * The calibration status consists of four pairs of two bits. Each pair
     * of bits represents the status of the current calibration.
     * 
     * * bit 0-1: Magnetometer
     * * bit 2-3: Accelerometer
     * * bit 4-5: Gyroscope
     * * bit 6-7: System
     * 
     * A value of 0 means for "not calibrated" and a value of 3 means
     * "fully calibrated". In your program you should always be able to
     * ignore the calibration status, it is used by the calibration
     * window of the Brick Viewer and it can be ignored after the first
     * calibration. See the documentation in the calibration window for
     * more information regarding the calibration of the IMU Brick.
     * 
     * If you want to get the data periodically, it is recommended 
     * to use the callback BrickIMUV2::CALLBACK_ALL_DATA and set the period with 
     * BrickIMUV2::setAllDataPeriod().
     * 
     * 
     * @return array
     */
    public function getAllData()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ALL_DATA, $payload);

        $payload = unpack('v3acceleration/v3magnetic_field/v3angular_velocity/v3euler_angle/v4quaternion/v3linear_acceleration/v3gravity_vector/c1temperature/C1calibration_status', $data);

        $result['acceleration'] = IPConnection::collectUnpackedInt16Array($payload, 'acceleration', 3);
        $result['magnetic_field'] = IPConnection::collectUnpackedInt16Array($payload, 'magnetic_field', 3);
        $result['angular_velocity'] = IPConnection::collectUnpackedInt16Array($payload, 'angular_velocity', 3);
        $result['euler_angle'] = IPConnection::collectUnpackedInt16Array($payload, 'euler_angle', 3);
        $result['quaternion'] = IPConnection::collectUnpackedInt16Array($payload, 'quaternion', 4);
        $result['linear_acceleration'] = IPConnection::collectUnpackedInt16Array($payload, 'linear_acceleration', 3);
        $result['gravity_vector'] = IPConnection::collectUnpackedInt16Array($payload, 'gravity_vector', 3);
        $result['temperature'] = $payload['temperature'];
        $result['calibration_status'] = $payload['calibration_status'];

        return $result;
    }

    /**
     * Turns the orientation and direction LEDs of the IMU Brick on.
     * 
     * 
     * @return void
     */
    public function ledsOn()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_LEDS_ON, $payload);
    }

    /**
     * Turns the orientation and direction LEDs of the IMU Brick off.
     * 
     * 
     * @return void
     */
    public function ledsOff()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_LEDS_OFF, $payload);
    }

    /**
     * Returns *true* if the orientation and direction LEDs of the IMU Brick
     * are on, *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function areLedsOn()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_ARE_LEDS_ON, $payload);

        $payload = unpack('C1leds', $data);

        return (bool)$payload['leds'];
    }

    /**
     * A call of this function saves the current calibration to be used
     * as a starting point for the next restart of continuous calibration
     * of the IMU Brick.
     * 
     * A return value of *true* means that the calibration could be used and
     * *false* means that it could not be used (this happens if the calibration 
     * status is not "fully calibrated").
     * 
     * This function is used by the calibration window of the Brick Viewer, you
     * should not need to call it in your program.
     * 
     * 
     * @return bool
     */
    public function saveCalibration()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_SAVE_CALIBRATION, $payload);

        $payload = unpack('C1calibration_done', $data);

        return (bool)$payload['calibration_done'];
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_ACCELERATION callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * The default value is 0.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setAccelerationPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ACCELERATION_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setAccelerationPeriod().
     * 
     * 
     * @return int
     */
    public function getAccelerationPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ACCELERATION_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_MAGNETIC_FIELD callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setMagneticFieldPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_MAGNETIC_FIELD_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setMagneticFieldPeriod().
     * 
     * 
     * @return int
     */
    public function getMagneticFieldPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_MAGNETIC_FIELD_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_ANGULAR_VELOCITY callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setAngularVelocityPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setAngularVelocityPeriod().
     * 
     * 
     * @return int
     */
    public function getAngularVelocityPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_TEMPERATURE callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setTemperaturePeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_TEMPERATURE_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setTemperaturePeriod().
     * 
     * 
     * @return int
     */
    public function getTemperaturePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_TEMPERATURE_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_ORIENTATION callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setOrientationPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ORIENTATION_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setOrientationPeriod().
     * 
     * 
     * @return int
     */
    public function getOrientationPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ORIENTATION_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_LINEAR_ACCELERATION callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setLinearAccelerationPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_LINEAR_ACCELERATION_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setLinearAccelerationPeriod().
     * 
     * 
     * @return int
     */
    public function getLinearAccelerationPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_LINEAR_ACCELERATION_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_GRAVITY_VECTOR callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setGravityVectorPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_GRAVITY_VECTOR_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setGravityVectorPeriod().
     * 
     * 
     * @return int
     */
    public function getGravityVectorPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_GRAVITY_VECTOR_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_QUATERNION callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setQuaternionPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_QUATERNION_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setQuaternionPeriod().
     * 
     * 
     * @return int
     */
    public function getQuaternionPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_QUATERNION_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the period in ms with which the BrickIMUV2::CALLBACK_ALL_DATA callback is triggered
     * periodically. A value of 0 turns the callback off.
     * 
     * @param int $period
     * 
     * @return void
     */
    public function setAllDataPeriod($period)
    {
        $payload = '';
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_ALL_DATA_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickIMUV2::setAllDataPeriod().
     * 
     * 
     * @return int
     */
    public function getAllDataPeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ALL_DATA_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Enables the status LED.
     * 
     * The status LED is the blue LED next to the USB connector. If enabled is is
     * on and it flickers if data is transfered. If disabled it is always off.
     * 
     * The default state is enabled.
     * 
     * 
     * @return void
     */
    public function enableStatusLED()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_ENABLE_STATUS_LED, $payload);
    }

    /**
     * Disables the status LED.
     * 
     * The status LED is the blue LED next to the USB connector. If enabled is is
     * on and it flickers if data is transfered. If disabled it is always off.
     * 
     * The default state is enabled.
     * 
     * 
     * @return void
     */
    public function disableStatusLED()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_DISABLE_STATUS_LED, $payload);
    }

    /**
     * Returns *true* if the status LED is enabled, *false* otherwise.
     * 
     * 
     * @return bool
     */
    public function isStatusLEDEnabled()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_IS_STATUS_LED_ENABLED, $payload);

        $payload = unpack('C1enabled', $data);

        return (bool)$payload['enabled'];
    }

    /**
     * Returns the firmware and protocol version and the name of the Bricklet for a
     * given port.
     * 
     * This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
     * plugins.
     * 
     * @param string $port
     * 
     * @return array
     */
    public function getProtocol1BrickletName($port)
    {
        $result = array();

        $payload = '';
        $payload .= pack('c', ord($port));

        $data = $this->sendRequest(self::FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, $payload);

        $payload = unpack('C1protocol_version/C3firmware_version/c40name', $data);

        $result['protocol_version'] = $payload['protocol_version'];
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['name'] = IPConnection::implodeUnpackedString($payload, 'name', 40);

        return $result;
    }

    /**
     * Returns the temperature in °C/10 as measured inside the microcontroller. The
     * value returned is not the ambient temperature!
     * 
     * The temperature is only proportional to the real temperature and it has an
     * accuracy of +-15%. Practically it is only useful as an indicator for
     * temperature changes.
     * 
     * 
     * @return int
     */
    public function getChipTemperature()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CHIP_TEMPERATURE, $payload);

        $payload = unpack('v1temperature', $data);

        return IPConnection::fixUnpackedInt16($payload, 'temperature');
    }

    /**
     * Calling this function will reset the Brick. Calling this function
     * on a Brick inside of a stack will reset the whole stack.
     * 
     * After a reset you have to create new device objects,
     * calling functions on the existing ones will result in
     * undefined behavior!
     * 
     * 
     * @return void
     */
    public function reset()
    {
        $payload = '';

        $this->sendRequest(self::FUNCTION_RESET, $payload);
    }

    /**
     * Returns the UID, the UID where the Brick is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be '0'-'8' (stack position).
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperAcceleration($data)
    {
        $result = array();
        $payload = unpack('v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ACCELERATION]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ACCELERATION], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperMagneticField($data)
    {
        $result = array();
        $payload = unpack('v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_MAGNETIC_FIELD]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_MAGNETIC_FIELD], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperAngularVelocity($data)
    {
        $result = array();
        $payload = unpack('v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ANGULAR_VELOCITY]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ANGULAR_VELOCITY], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperTemperature($data)
    {
        $result = array();
        $payload = unpack('c1temperature', $data);

        array_push($result, $payload['temperature']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_TEMPERATURE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_TEMPERATURE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperLinearAcceleration($data)
    {
        $result = array();
        $payload = unpack('v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_LINEAR_ACCELERATION]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_LINEAR_ACCELERATION], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperGravityVector($data)
    {
        $result = array();
        $payload = unpack('v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_GRAVITY_VECTOR]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_GRAVITY_VECTOR], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperOrientation($data)
    {
        $result = array();
        $payload = unpack('v1heading/v1roll/v1pitch', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'heading'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'roll'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'pitch'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ORIENTATION]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ORIENTATION], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperQuaternion($data)
    {
        $result = array();
        $payload = unpack('v1w/v1x/v1y/v1z', $data);

        array_push($result, IPConnection::fixUnpackedInt16($payload, 'w'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'x'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'y'));
        array_push($result, IPConnection::fixUnpackedInt16($payload, 'z'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_QUATERNION]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_QUATERNION], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperAllData($data)
    {
        $result = array();
        $payload = unpack('v3acceleration/v3magnetic_field/v3angular_velocity/v3euler_angle/v4quaternion/v3linear_acceleration/v3gravity_vector/c1temperature/C1calibration_status', $data);

        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'acceleration', 3));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'magnetic_field', 3));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'angular_velocity', 3));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'euler_angle', 3));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'quaternion', 4));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'linear_acceleration', 3));
        array_push($result, IPConnection::collectUnpackedInt16Array($payload, 'gravity_vector', 3));
        array_push($result, $payload['temperature']);
        array_push($result, $payload['calibration_status']);
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_ALL_DATA]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_ALL_DATA], $result);
    }
}

?>
